package com.manage.service.cache;

import com.manage.vo.Power_UserVo;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public class CacheManager {
    private static HashMap cacheMap = new HashMap();
    //添加异常数量
    public static void addExcCount(String type){
        if("noExc".equals(type)){
        }
        if("exc".equals(type)){
        }
    }

    private  static Cache getCache(String key) {
        return (Cache) cacheMap.get(key);
    }

    private  static boolean hasCache(String key) {
        return cacheMap.containsKey(key);
    }

    public  static void clearAll() {
        cacheMap.clear();
    }

    public  static void clearAll(String type) {
        Iterator i = cacheMap.entrySet().iterator();
        String key;
        ArrayList<String> arr = new ArrayList<String>();
        try {
            while (i.hasNext()) {
                Map.Entry entry = (Map.Entry) i.next();
                key = (String) entry.getKey();
                if (key.startsWith(type)) {
                    arr.add(key);
                }
            }
            for (String s : arr) {
                clearOnly(s);
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public  static void clearOnly(String key) {
        cacheMap.remove(key);
    }

    public  static void putCache(String key, Cache obj) {
        cacheMap.put(key, obj);
    }

    public static Cache getCacheInfo(String key) {
        if (hasCache(key)) {
            Cache cache = getCache(key);
            if (cacheExpired(cache)) {
                cache.setExpired(true);
            }
            return cache;
        }else
            return null;
    }

    private static boolean cacheExpired(Cache cache) {
        if (null == cache) {
            return false;
        }
        long nowDt = System.currentTimeMillis();
        long cacheDt = cache.getTimeOut();
        if (cacheDt <= 0||cacheDt>nowDt) {
            return false;
        } else {
            return true;
        }
    }

    //根据用户信息删除缓存
    public synchronized static void removeCacheByObject(Power_UserVo obj) {
        ArrayList<String> arr = new ArrayList<String>();
        try {
            Iterator i = cacheMap.entrySet().iterator();
            while (i.hasNext()) {
                Map.Entry entry = (Map.Entry) i.next();
                Cache cache = CacheManager.getCacheInfo((String)entry.getKey());
                Power_UserVo o = (Power_UserVo)cache.getValue();
                if (obj.getUserName().equals(o.getUserName())) {
                    arr.add((String)entry.getKey());
                }
            }
            if(!arr.isEmpty()){
                for (String s : arr) {
                    clearOnly(s);
                }
            }
        } catch (Exception ignored) {}
    }
}